<?php
if (!isset($SITE)){
	header ("Location: ../index.php");	// back to index/startpage if someone tries an
	exit;  								//  page to load without menu system//
}
$pageName		= 'noaaPlainCreateArr.php';
$pageVersion	= '4.5x 2014-01-26';
$SITE['wsModules'][$pageName] = 'version: ' . $pageVersion;
$pageFile = basename(__FILE__);			// check to see this is the real script
if ($pageFile <> $pageName) {
	$SITE['wsModules'][$pageFile]	= 'this file loaded instead of '.$pageName;
}
$myPageNoaa1	= $pageName;
echo '<!-- module '.$pageFile.' ==== '.$SITE['wsModules'][$pageFile]." -->".PHP_EOL;
#--------------------------------------------------------------------------------------------------
# retrieve weather info from weathersource noaa
# This is the "plain text" like xml
# and return array with retrieved data in the desired units C/F.
# with noaa no translation is possible nor needed for the moment
#	&lat  = latitude   &lon  = longitude
#    <description>Branford, CT</description>
#   <point latitude="41.3" longitude="-72.8"/>
#--------------------------------------------------------------------------------------------------
# retrieve weather infor from weathersource  
# and return array with retrieved data in the desired language and units C/F
#--------------------------------------------------------------------------------------------------
class noaaPlainWeather{
	# public variables
	public $lat				= '41.3';	// 
	public $lon				= '-72.8';	// 
# private variables
	private $uomTemp		= 'F';		// <temperature type="maximum" units="Fahrenheit" 
	private $uomWindDir		= 'deg';		// <direction type="wind" units="degrees
	private $uomWindSpeed	= 'kts';		// <wind-speed type="sustained" units="knots"
	private $uomHum			= 'percent';	// <humidity type="relative" 
	private $uomBaro		= 'inHg';		// <pressure type="barometer" units="inches of mercury"
	private $uomCloud		= 'percent';	// 
	private $uomRain		= 'in';
	private $uomDistance	= 'mi';			// <visibility units="statute miles">
	private $uomPoP			= '%';			// <probability-of-precipitation  units="percent"
	
	private $enableCache	= true; 		// cache should be anabled when frequent request are made. Keep in mind that the data is only refreshed every hour by google 
	private $cache			= 'cache';		// cache dir is created when not available
	private $cacheTime 		= 3600; 			// Cache expiration time Default: 3600 seconds = 1 Hour
	private $cacheFile		= 'xxx';
	private $apiUrlpart 	= array(		// http://forecast.weather.gov/MapClick.php?lat=41.3&lon=-72.78&FcstType=dwml
	 0 => 'http://forecast.weather.gov/MapClick.php?lat=',
	 1 => 'userinputLatitude',
	 2 => '&lon=',
	 3 => 'userinputLatitude',
	 4 => '&FcstType=dwml',
	);
	private $weatherApiUrl	= '';
	private $rawData		= '';
#--------------------------------------------------------------------------------------------------
# public functions	
#--------------------------------------------------------------------------------------------------
	public function getWeatherData($lat = '', $lon = '') {
		global $SITE, $myPageNoaa1;
		#----------------------------------------------------------------------------------------------
		# clean user input
		#----------------------------------------------------------------------------------------------
		$this->apiUrlpart[1] = trim($lat);
		$this->apiUrlpart[3] = trim($lon);
		#----------------------------------------------------------------------------------------------
		# try loading data from cache
		#----------------------------------------------------------------------------------------------		
		if ( $this->enableCache && !empty($this->cache) ){
			$this->cache	= $SITE['cacheDir'];
			$uoms			= $SITE['uomTemp'].'-'.$SITE['uomWind'].'-'.$SITE['uomRain'].'-'.$SITE['uomBaro'].'-'.$SITE['uomDistance'];
			$from			= array('&deg;','','/',' ');
			$to				= array('','','','');
			$uoms			= str_replace($from,$to,$uoms);
			$this->cacheFile= $this->cache . $myPageNoaa1 . '-' .$this->apiUrlpart[1]. '|' . $this->apiUrlpart[3] . '-' .$uoms;
			$returnArray	= $this->loadFromCache();	// load from cache returns data only when its data is valid
			if (!empty($returnArray)) {
				return $returnArray;					// if data is in cache and valid return data to calling program
			}	// eo valid data, return to calling program
		}  		// eo check cache
		#----------------------------------------------------------------------------------------------
		# combine everything into required url
		#  http://forecast.weather.gov/MapClick.php?lat=41.3&lon=-72.78&FcstType=dwml
		#----------------------------------------------------------------------------------------------
		$this->weatherApiUrl = '';
		$end	= count($this->apiUrlpart);
		for ($i = 0; $i < $end; $i++){
			$this->weatherApiUrl .= $this->apiUrlpart[$i];
		}
		#----------------------------------------------------------------------------------------------		
		if ($this->makeRequest()) {  	// load xml from url and process
			$this->rawData = str_replace ('-name','_name',$this->rawData);
			$xml = new SimpleXMLElement($this->rawData);
#			echo '<pre>'.PHP_EOL;  
#			print_r ($xml); 
#			echo 'test'; 
#			var_dump( $xml->data[0]->{'time-layout'}[1]->{'start-valid-time'}[1]['period_name']);
#			echo (string)  $xml->data[0]->{'time-layout'}[1]->{'start-valid-time'}[1]['period_name'];
#			exit;
			$returnArray = array();
			$utcDiff 								= date('Z');// to help to correct utc differences
			$string		= (string) $xml->head->product->{'creation-date'};
			$time		= strtotime($string);
			$returnArray['information']['filetime']		= date('c', strtotime($string ) );
			$returnArray['information']['updated']		= date($SITE['dateLongFormat'], $time).' '.date($SITE['timeOnlyFormat'], $time);			
			$returnArray['information']['location']		= (string) $xml->data[0]->location->description;
			if ($returnArray['information']['location'] == '' ) {
				$returnArray['information']['location']		= (string) $xml->data[0]->location->{'area-description'};			
			}
			$returnArray['information']['issued']		= (string) $xml->head->source->{'production-center'};
			
#--------------------------------------------------------------------------------------------------
#  get forecast info
#--------------------------------------------------------------------------------------------------
			$i=0;
			$returnArray['forecast'][$i]['dayPart'] 	= 'daypart';	// <start-valid-time period-name="Today
			$returnArray['forecast'][$i]['startTime'] 	= 'startTime';	// <start-valid-time period->2013-05-24T06:00:00-04:00</start-valid-time>			
			$returnArray['forecast'][$i]['endTime'] 	= 'endTime';	// <end-valid-time>2013-05-30T18:00:00-04:00</end-valid-time>			
# <temperature type="maximum" units="Fahrenheit" time-layout="k-p24h-n7-1"><value>68</value>
# <temperature type="minimum" units="Fahrenheit" time-layout="k-p24h-n6-2"><value>50</value>			
			$returnArray['forecast'][$i]['tempMaxNU'] 	= 'temp';
			$returnArray['forecast'][$i]['tempMax'] 	= 'temp';
			$returnArray['forecast'][$i]['tempMinNU'] 	= 'temp';
			$returnArray['forecast'][$i]['tempMin'] 	= 'temp';	
# <probability-of-precipitation  type="12 hour" units="percent" time-layout="k-p12h-n13-1">
			$returnArray['forecast'][$i]['PoP'] 		= 'PoP';
# <weather time-layout="k-p12h-n13-1"><name>Weather Type, Coverage, Intensity</name><weather-conditions weather-summary="Showers"/>
			$returnArray['forecast'][$i]['weatherDescShort']	= 'condition';	// Showers
			$returnArray['forecast'][$i]['weatherDescText']	= 'condition Description';	// Showers and possibly a thunderstorm.  High near 68. Southwest
			$returnArray['forecast'][$i]['icon']		= 'icon code';	// nra90	
			$returnArray['forecast'][$i]['iconUrl']		= 'icon Url';	// http://forecast.weather.gov/images/wtf/medium/ra80.png	
			$endLayouts	= count ($xml->data[0]->{'time-layout'});
			$arrTimes	= array();
			for ($nLayouts = 0; $nLayouts < $endLayouts; $nLayouts++) {
				$forecast = $xml->data[0]->{'time-layout'}[$nLayouts];
				$endTimes = count($forecast->{'start-valid-time'});
				$layoutKey = (string) $forecast->{'layout-key'};
				for ($nTimes = 0; $nTimes < $endTimes; $nTimes++) {
					$key 		= $layoutKey.'|'.$nTimes;
					$startTime	= (string) $forecast->{'start-valid-time'}[$nTimes];
					$daypart	= (string) $forecast->{'start-valid-time'}[$nTimes]['period_name'];
					$arrTimes[$key]['startTime']= $startTime;
					if ($daypart <> '') {$arrTimes[$key]['daypart'] 	= $daypart;}
					$endTime	= (string) $forecast->{'end-valid-time'}[$nTimes];
					if ($endTime <> '') {$arrTimes[$key]['endTime']= $endTime;}
				}  // eof times
			}  // eof layouts
			
			$endTemp = count ($xml->data[0]->parameters->temperature);
			for ($nTemp = 0; $nTemp < $endTemp; $nTemp++) {
				$temps 		= $xml->data[0]->parameters->temperature[$nTemp];
#				print_r($temps);
				$layoutKey	= (string) $temps['time-layout'];
				$string		= (string) $temps['type'];
				if ($string == 'maximum') {$valueKey = 'tempMax';} else {$valueKey = 'tempMin';}
				$string		= (string) $temps['units'];
				$uomTemp = substr($string,0,1);
				$endValue	= count ($temps->value);
#				echo '$endValue '.$endValue ; exit;
				for ($nValue = 0; $nValue < $endValue; $nValue++) {
					$key 		= $layoutKey.'|'.$nValue;
					$string 	= (string) $temps->value[$nValue]; 
					$value		= round( wsConvertTemperature($string,$uomTemp) );
					$arrTimes[$key][$valueKey.'NU'] = $value;
					$arrTimes[$key][$valueKey] = $value.$SITE['uomTemp'];
				}
			}
			$endPoP = count ($xml->data[0]->parameters->{'probability-of-precipitation'});
			for ($nPoP = 0; $nPoP < $endPoP; $nPoP++) {
				$PoPs 		= $xml->data[0]->parameters->{'probability-of-precipitation'}[$nPoP];
#				print_r($PoPs);
				$layoutKey	= (string) $PoPs['time-layout'];
				$valueKey	= 'PoP';				
				$endValue	= count ($PoPs->value);
#				echo '$endValue '.$endValue ; exit;
				for ($nValue = 0; $nValue < $endValue; $nValue++) {
					$key 		= $layoutKey.'|'.$nValue;
					$arrTimes[$key][$valueKey] = (string) $PoPs->value[$nValue];
				}
			}
			$endCondition = count ($xml->data[0]->parameters->{'weather'});
			for ($nCondition = 0; $nCondition < $endCondition; $nCondition++) {
				$Conditions 		= $xml->data[0]->parameters->{'weather'}[$nCondition];
#				print_r($Conditions);
				$layoutKey	= (string) $Conditions['time-layout'];
				$valueKey	= 'weatherDescShort';				
				$endValue	= count ($Conditions->{'weather-conditions'});
#				echo '$endValue '.$endValue ; exit;
				for ($nValue = 0; $nValue < $endValue; $nValue++) {
					$key 		= $layoutKey.'|'.$nValue;
					$value 		= (string) $Conditions->{'weather-conditions'}[$nValue]{'weather-summary'};
					$arrTimes[$key][$valueKey] = $value;	 
				}
			}
			$endIcon = count ($xml->data[0]->parameters->{'conditions-icon'});
			for ($nIcon = 0; $nIcon < $endIcon; $nIcon++) {
				$Icons 		= $xml->data[0]->parameters->{'conditions-icon'}[$nIcon];
#				print_r($Icons);
				$layoutKey	= (string) $Icons['time-layout'];
				$valueKey	= 'iconUrl';				
				$endValue	= count ($Icons->{'icon-link'});
#				echo '$endValue '.$endValue ; exit;
				for ($nValue = 0; $nValue < $endValue; $nValue++) {
					$key 		= $layoutKey.'|'.$nValue;
					$value 		= (string) $Icons->{'icon-link'}[$nValue];
					$arrTimes[$key][$valueKey] = $value;
				}
			}
			$endhazards = count ($xml->data[0]->parameters->{'hazards'});
			$returnArray['information']['hazards'] = $endhazards;
			for ($nhazards = 0; $nhazards < $endhazards; $nhazards++) {
				$hazards 		= $xml->data[0]->parameters->{'hazards'}[$nhazards];
#				print_r($hazards);
				$layoutKey	= (string) $hazards['time-layout'];				
				$endValue	= count ($hazards->{'hazard-conditions'}->hazard);
#				echo '$endValue '.$endValue ; exit;
				for ($nValue = 0; $nValue < $endValue; $nValue++) {
					$key 		= $layoutKey.'|'.$nValue;
					$string = (string) $hazards->{'hazard-conditions'}->hazard[$nValue]->hazardTextURL;
					$arrTimes[$key]['hazardUrl']= str_replace('&','&amp;',$string);
					$arrTimes[$key]['hazardType']	= (string) $hazards->{'hazard-conditions'}->hazard[$nValue]{'headline'};	 
				}
			}
			$endWord = count ($xml->data[0]->parameters->{'wordedForecast'});
			for ($nWord = 0; $nWord < $endWord; $nWord++) {
				$Words 		= $xml->data[0]->parameters->{'wordedForecast'}[$nWord];
#				print_r($Words);
				$layoutKey	= (string) $Words['time-layout'];
				$valueKey	= 'weatherDescText';				
				$endValue	= count ($Words->{'text'});
#				echo '$endValue '.$endValue ; exit;
				for ($nValue = 0; $nValue < $endValue; $nValue++) {
					$key 		= $layoutKey.'|'.$nValue;
					$value 		= (string) $Words->{'text'}[$nValue];
					$arrTimes[$key][$valueKey] = $value;	 
				}
			}
#			echo '<pre>'.PHP_EOL; print_r ($arrTimes); exit;
			foreach ($arrTimes as $key => $arr) {
				if (!isset ($arr['hazardType']) ) {
					$type	= 'forecast';
					$start	= $arr['startTime']; 
				} else {
					$type	= 'hazard';
					$start	= $arr['hazardType']; 
				}	
#				$returnArray[$type][$start]['startTime']=$start;
				foreach ($arr as $keyValue => $value) {
#					echo $keyValue.' - '.$value.PHP_EOL;
#					if ($keyValue == 'startTime') {continue;}
					$returnArray[$type][$start][$keyValue]=$value;
				}
			}
			foreach ($returnArray['forecast'] as $key => $arr) {
				if (!isset ($arr['PoP']) || !isset ($arr['iconUrl'] ) || $key == 0){continue;}
				$remove		= $arr['PoP'];
				$arrparts	= explode('/',$arr['iconUrl']);
				$location	= count($arrparts)-1;
				$value		= $arrparts[$location];
				$iconPoP	= $none = '';
				list($iconPoP,$none) = explode('.',$value);
				$icon		= str_replace ($remove,'',$iconPoP);
				$returnArray['forecast'][$key]['noaaIcon'] = $icon;
				$ret = wsChangeIcon ('noaa',$icon, $icon, $none, $none);
				$returnArray['forecast'][$key]['defaultIcon'] = $icon;
			}
#		echo '<pre>'.PHP_EOL; print_r ($returnArray); exit;
		$ret = $this->writeToCache($returnArray);
		return $returnArray;
		}  // eo makeRequest processing

	} // eof getWeatherData
	
	private function loadFromCache(){
		if (file_exists($this->cacheFile)){	
			$file_time = filectime($this->cacheFile);
			$now = time();
			$diff = ($now-$file_time);		
			if ($diff <= $this->cacheTime){
				echo "<!-- weatherdata ($this->cacheFile) loaded from cache  -->".PHP_EOL;
				$returnArray =  unserialize(file_get_contents($this->cacheFile));
				return $returnArray;
			}
		}	
	} // eof loadFromCache
	
	private function writeToCache($data){
		if (!file_exists($this->cache)){
			mkdir($this->cache, 0777);   // attempt to make the cache dir
		}
	//			print_r ($data); return;
		if (!file_put_contents($this->cacheFile, serialize($data))){   
			echo PHP_EOL."<!-- Could not save data ($this->cacheFile) to cache ($this->cacheFile). Please make sure your cache directory exists and is writable. -->".PHP_EOL;
		} else {echo "<!-- Weatherdata ($this->cacheFile) saved to cache  -->".PHP_EOL;}
	} // eof writeToCache
	
	private function makeRequest(){
		global $SITE;
		$test = false;
		if ($test == true) {
			$this->rawData  = file_get_contents('./noaa/dwml.xml');
#			$this->rawData  = file_get_contents('./noaa/digitalDWML.xml');
#			print_r ($this->rawData); exit;
		} else {
		$ch = curl_init();
		curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt ($ch, CURLOPT_URL, $this->weatherApiUrl);
		curl_setopt($ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
		curl_setopt ($ch, CURLOPT_TIMEOUT, 60);
#		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, $SITE['curlFollow']);
		$this->rawData = curl_exec ($ch);
		curl_close ($ch);
		}
//		echo $this->weatherApiUrl;

		if (empty($this->rawData)){
			return false;
		}
		$search = array ('Service Unavailable','Error 504','Error 503');
		$error = false;
		for ($i = 0; $i < count($search); $i++) {
			$int = strpos($this->rawData , $search[$i]);
			if ($int > 0) {$error = true; break;}
		}
		if ($error == false) {return true;	} else {return false;}
	} // eof makeRequest
	
}