<?php
if (!isset($SITE)){
	header ("Location: ../index.php");	// back to index/startpage if someone tries an
	exit;  								//  page to load without menu system//
}
$pageName		= 'noaaPlainGenerateHtml.php';
$pageVersion	= '4.5x 2014-01-26';
$SITE['wsModules'][$pageName] = 'version: ' . $pageVersion;
$pageFile = basename(__FILE__);			// check to see this is the real script
if ($pageFile <> $pageName) {
	$SITE['wsModules'][$pageFile]	= 'this file loaded instead of '.$pageName;
}
echo '<!-- module '.$pageFile.' ==== '.$SITE['wsModules'][$pageFile]." -->".PHP_EOL;
#-------------------------------------------------------------------------------
# Display a list of forecast date from nws/noaa
#
#-------------------------------------------------------------------------------
# First get the data from the weather class
$script	= 'noaaPlainCreateArr.php';
echo '<!-- trying to load '.$script.' -->'.PHP_EOL;
include($script);
$weather 		= new noaaPlainWeather ();
$returnArray 	= $weather->getWeatherData($SITE['latitude'],$SITE['longitude']);
#$returnArray 	= $weather->getWeatherData('41.30068','-72.793671');  // demonstration no info for europe
#-------------------------------------------------------------------------------
# now we generate the html to be used for output to the screen
#
$city = $returnArray['information']['location'];
$line1= 'National Weather Service '.langtransstr('forecast for').': <span style="color: green;">'.$city.'</span>';
$line2= langtransstr('Issued by').': '.'National Weather Service '.$returnArray['information']['issued'];
$line3= langtransstr('Updated').  ': '.$returnArray['information']['updated']; 
# These are the first three lines on the one page city forecast
$stringTop ='<div style="text-align: center;">'.$line1.'<br />'.$line2.'<br />'.$line3.'</div>';

# the icons 
if ($SITE['noaaIconsOwn']) {$showPoP = false;} else  {$showPoP = true;}
$tdWidth=floor(100 / $topCount).'%';
$daypart 	= $icon = $PoP = $desc = $temp = '';
$noaaIcons 	='
<table class= "genericTable" style="width: 100%;">
  <tbody>
';
$first='    <tr>
      <td style="width: '.$tdWidth.'; vertical-align: top; text-align:center;  font-size: 80%;">';
$PoPNeeded	= false;
$count	= 1;
foreach ($returnArray['forecast'] as $key => $arr) {
	if (!isset ($arr['PoP']) || !isset ($arr['iconUrl'] ) || $key == 0){continue;}   // skip all other information
	if ($count > $topCount) {break;} else {$count++;}
	$arrTxt = explode (' ',$arr['daypart'].' &nbsp;');
	$daypartTxt = str_replace($arrTxt[0],$arrTxt[0].'<br />&nbsp;',$arr['daypart']);
	$daypart	.= $first.'<span style="font-weight: bold;">'.$daypartTxt.'</span></td>';
	$iconImg	='<img src="';
	if ($SITE['noaaIconsOwn']) {
		$iconImg 	.= $arr['iconUrl'];
	} else {
		$iconImg 	.= $SITE['defaultIconsDir'].$arr['defaultIcon'].'.png';
	}
	$iconImg	.= '" style="width: '.$wsIconWidth .';" title="'.$arr['weatherDescShort'].'" alt="'.$arr['weatherDescShort'].'">';
	$icon		.= $first.$iconImg.'</td>';
	if ($showPoP && $arr['PoP'] > 0) {
		$PoP	.= $first.'PoP: '.$arr['PoP'].'%</td>';
		$PoPNeeded	= true;
	} else {$PoP .= $first.'</td>';}
	$descTxt	= str_replace('Slight Chc','Slight&nbsp;Chc',trim($arr['weatherDescShort']) );
	$descTxt	= str_replace(' ','<br />',$descTxt );
	$desc		.= $first.$descTxt.'</td>';
	if (isset ($arr['tempMin']) ){
		$temp	.= $first.'Lo: <span style="color: blue;">'.$arr['tempMin'].'</span></td>';
	} else {
		$temp	.= $first.'Hi: <span style="color: red;">'.$arr['tempMax'].'</span></td>';
	}
	$first='
      <td style="width: '.$tdWidth.'; vertical-align: top; text-align:center; font-size: 80%;">';
}
$daypart.= '
    </tr>'.PHP_EOL;
$icon	.= '
    </tr>'.PHP_EOL;
if ($showPoP) {$PoP	.= '
    </tr>'.PHP_EOL;}
$desc	.= '
    </tr>'.PHP_EOL;
$temp	.= '
    </tr>'.PHP_EOL;

$noaaIcons .= $daypart.$icon;
if ($PoPNeeded == true) {$noaaIcons .= $PoP;}
$noaaIcons .= $desc.$temp.'  <tbody>
</table>'.PHP_EOL;

# -----------   are there any warnings
$hazardsString	= '';
if ($returnArray['information']['hazards']<> 0) {
	$hazardsString = '<div style="width: 100%; background-color: #FFF0F0; font-weight: bold; border-bottom-style: solid; border-bottom-width: 1px; border-bottom-color: #980000;">
  <p style="width: 100%; background-color: #980000; margin: 0px; padding: 3px 0px; color: white;">&nbsp;&nbsp;&nbsp;HAZARDOUS&nbsp;&nbsp;WEATHER&nbsp;&nbsp;CONDITIONS</p>
    <p style="padding: 5px 0px 10px 15px; margin: 0px; font-size: 110%; color: #980000;">'.PHP_EOL;
	foreach ($returnArray['hazard'] as $key => $arr) {
		$hazardsString .= '    <a href="'.$arr['hazardUrl'].'" style="color: #980000; ">'.$arr['hazardType'].'</a><br />'.PHP_EOL;
	}  // eo each forecast
	$hazardsString .= '</p></div>'.PHP_EOL;	

}  // eo hazards
# -----------
$noaaPlainTextHead = '<p style="margin: 4px; color: blue; font-size: 200%;">7-DAY FORECAST</p>'.PHP_EOL;
$rowColor	= 'row-dark'; // = row-light;
$noaaPlainText= '
<table class="genericTable" style="width: 100%;  text-align:left;">
  <tbody>'.PHP_EOL;
foreach ($returnArray['forecast'] as $key => $arr) {
	if (!isset ($arr['PoP']) || !isset ($arr['iconUrl'] ) || $key == 0){continue;}   // skip all other information
	$arrTxt = explode (' ',$arr['daypart'].' &nbsp;');
	$daypartString = str_replace($arrTxt[0],$arrTxt[0].'<br />&nbsp;',$arr['daypart']);
	$noaaPlainText .= '
    <tr class="'.$rowColor.'" >
      <td style="vertical-align: top; text-align:right;  font-weight:bold; padding: 10px 10px 10px 10px;"><span style="">'.$daypartString.'</span></td>';
    $noaaPlainText .= '
      <td  style="vertical-align: top; padding: 10px 10px 10px 10px;">'.$arr['weatherDescText'].'</td>
    </tr>'.PHP_EOL;
    if ($rowColor	== 'row-dark') {$rowColor	= 'row-light';} else {$rowColor	= 'row-dark';}
}
$noaaPlainText .= '
  <tbody>
</table>
<br />'.PHP_EOL;
$city=str_replace(' ','%20',$city);
$creditLink = '&nbsp;Forecast from <a href="http://forecast.weather.gov/MapClick.php?CityName='.$city.'" target="_blank">NOAA-NWS</a> for '.$city.'<br /><br />';


# ================

#---------------------------------------------------------------------------
?>
